#
# check-libs-and-binaries.csh
#
set files = ( \
  hibutil/lsgrape \
  hibutil/libhib.a \
  hibutil/hibtest  \
  hibutil/dmatest  \
  singlibMC_tb4/singtest \
  singlibMC_tb4/libsing.a \
  singlibMC_tb4/ctrltest \
  singlibMC_tb4/errorcheck \
  singlibMC_tb4/ctrltest-nobcast \
  singlibMC_tb4/g5work/testsimplegravity \
  singlibMC_tb4/g5work/libgdrgrav.a \
  singlibMC_tb4/g5work/grape-g5 \
  singlibMC_tb4/hermite/libgdrg6.a \
  singlibMC_tb4/hermite/testgrape6 \
  singlibMC_tb4/pit/pit_lx \
  singlibMC_tb4/pit/pit_gdrg6_lx )
cd $GDRBASEDIR/gdrtb3
#echo directory = $cwd
set not_ok = 0
foreach  f ( $files )
#   echo testing file $f
   if ( ! ( -e $f ) ) then
        set not_ok = 1
	echo File $f missing
   endif
end
if ( $not_ok == 0) then
   echo make succeeded
   exit 0
else
   echo make failed
   exit 1
endif
   
      
   
   
  
