#!/usr/bin/env ruby
#
# singinit-onecard.rb
#
# try singinit0.csh and singinit2.csh many times...
#
require 'pty'
require 'expect'

module Expect
  def spawn(cmd)
    puts "CMD: #{cmd}" if $expect_verbose
    PTY.spawn(cmd) { |r,w,pid|
      @input_stream = r
      @output_stream = w
      @child_pid = pid
      yield
    }
  end
  
  def myexpect(pat, timeout=5)
     @input_stream.expect(pat, timeout)
  end
end

include Expect
def trial(scriptname, waittext)
  STDERR.print "trying #{scriptname}..."
  spawn(scriptname) {
    begin
      if myexpect(waittext, 30)!= nil
        STDERR.print "command #{scriptname} normal end\n"
        return true
      end
      rescue
        STDERR.print "command #{scriptname} timeout\n"
      end
    }
  return false
end

dgemmcomm = "/usr2/makino/src/gdrlib/gdrtb3/singlibMC_tb4/libdgemm2-tst/testdgemm2amd"
#trial("cat /tmp/aho")
(1..5).each{|i|
  STDERR.print "trial #{i}\n"
#  trial("/usr2/makino/bin/singinit0.csh")
  system("/usr2/makino/bin/singinit0.csh")
  x = $?.exitstatus
#  p x
  if ( x == 0) then
    print "1st path normal end \n"
    system("/usr2/makino/bin/singinit0.csh")
    xx = $?.exitstatus
    if  (xx == 0) then
      print "2nd path normal end \n"
#      exit 0
# the following should be actibated for machines with
#EPROM later than 2010/5
      system("#{dgemmcomm} -b 0")
      if (FileTest.exist?("/dev/grape7e7")) then
        system("#{dgemmcomm} -b 1")
        system("#{dgemmcomm} -N2")
      end
      xxx = $?.exitstatus
      if (xxx == 0)
        exit 0
      end
    end
  end
}
print "initialization failed\n"
trial("/usr2/makino/bin/singinit2.csh", "reference")
print "rebooting...\n"
system ("/sbin/reboot")




