#!/bin/csh -f
#
# singinit0.csh
# By Makino. A completely new version

set hibdir = ${GDRBASEDIR}/gdrtb3/hibutil
set bindir = ${GDRBASEDIR}/gdrtb3/singlibMC_tb4

#cd $hibdir

set cards = "0 1 2 3"
if ( -e /dev/grape7e7 ) then
   set cards = "0 1 2 3 4 5 6 7"
endif
sleep 1


# 25 : 433MHz?
# 24 : 400MHz
# 22 : 366MHz ?
# 20 : 333MHz ?
${GDRBASEDIR}/gdrtb3/singlibMC_tb4/pllconf/pllconf 0 24
${GDRBASEDIR}/gdrtb3/singlibMC_tb4/pllconf/pllconf 1 24

echo run hibtest 14

$hibdir/hibtest 14
sleep 1
$hibdir/hibtest 14
sleep 1
$hibdir/hibtest 14
sleep 1


foreach i ( $cards )
  ${hibdir}/dmatest -t 113 -i $i
  ${hibdir}/dmatest -t 113 -i $i
end  
foreach i ( $cards )
   ${bindir}/ctrltest-nobcast $i < ${bindir}/testvector/testgravity &
end

sleep 5

${bindir}/singtest >& /tmp/singtest.log.$$
if ( $status != 0 ) then
   cat /tmp/singtest.log
   echo "singtest failed"
   exit -1
endif
cat /tmp/singtest.log.$$
cat <<EOF >/tmp/singtest.reflog.$$
chip 0 : 4.000000e+00 4.000000e+00 4.000000e+00 4.000000e+00   error=0
chip 1 : 8.000000e+00 8.000000e+00 8.000000e+00 8.000000e+00   error=0
chip 2 : 1.600000e+01 1.600000e+01 1.600000e+01 1.600000e+01   error=0
chip 3 : 1.200000e+01 1.200000e+01 1.200000e+01 1.200000e+01   error=0
EOF
tail -4 /tmp/singtest.log.$$ > /tmp/singtest.endlog.$$
diff /tmp/singtest.endlog.$$   /tmp/singtest.reflog.$$
if ( $status != 0 ) then
   cat /tmp/singtest.log.$$
   echo "singtest failed"
   rm /tmp/singtest.*
   exit -1
endif
rm /tmp/singtest.*


