#include "vpm-local.h"
#include "vpm-sim-defs.h"
#include "vpm-board-sim-defs.h"
#define grape_j_particle_struct  gravity_elt_struct0
struct gravity_hlt_struct0{
  double xi;
  double yi;
  double zi;
  double ascale;
  double pscale;
  UINT32 idxi;
};
struct gravity_hlt_vector_struct0{
  double xi[4];
  double yi[4];
  double zi[4];
  double ascale[4];
  double pscale[4];
  UINT32 idxi[4];
};
int gravity_send_i_particle(struct gravity_hlt_struct0 *ip,
                         int n);
#define grape_i_particle_struct gravity_hlt_struct0
#define grape_i_particle_vector_struct gravity_hlt_vector_struct0
struct gravity_elt_struct0{
  double xj;
  double yj;
  double zj;
  double mj;
  double eps2;
  UINT32 idxj;
};
int gravity_send_elt_data0(struct gravity_elt_struct0 *ip, int index_in_EM);
int gravity_move_elt_data0(int index);


struct gravity_result_struct{
  double accx;
  double accy;
  double accz;
  double pot;

};
struct gravity_result_vectorstruct{
  double accx[128];
  double accy[128];
  double accz[128];
  double pot[128];

};
int gravity_get_result(struct gravity_result_struct *rp);
#define  grape_result_struct gravity_result_struct 
void gravity_grape_init();
int gravity_grape_run(int n);
int gravity_type2_run(int n, void * loopout);
