//#include "vpm-local.h"
//#include "vpm-sim-defs.h"
//#include "vpm-board-sim-defs.h"

#ifndef __MUTMUL3232__

#define __MUTMUL3232__

#include <singMC.h>
#include "./dgemmconf.h"

#define NCHIP 4

#define grape_j_particle_struct  matmul_elt_struct0
struct matmul_hlt_struct0{
  double a0;
  double a1;
  double a2;
  double a3;
  double a4;
  double a5;
  double a6;
  double a7;
  double a8;
  double a9;
  double a10;
  double a11;
  double a12;
  double a13;
  double a14;
  double a15;
  double a16;
  double a17;
  double a18;
  double a19;
  double a20;
  double a21;
  double a22;
  double a23;
  double a24;
  double a25;
  double a26;
  double a27;
  double a28;
  double a29;
  double a30;
  double a31;
  double a32;
  double a33;
  double a34;
  double a35;
  double a36;
  double a37;
  double a38;
  double a39;
  double a40;
  double a41;
  double a42;
  double a43;
  double a44;
  double a45;
  double a46;
  double a47;
  double a48;
  double a49;
  double a50;
  double a51;
  double a52;
  double a53;
  double a54;
  double a55;
  double a56;
  double a57;
  double a58;
  double a59;
  double a60;
  double a61;
  double a62;
  double a63;
};
struct matmul_hlt_vector_struct0{
  double a0[4];
  double a1[4];
  double a2[4];
  double a3[4];
  double a4[4];
  double a5[4];
  double a6[4];
  double a7[4];
  double a8[4];
  double a9[4];
  double a10[4];
  double a11[4];
  double a12[4];
  double a13[4];
  double a14[4];
  double a15[4];
  double a16[4];
  double a17[4];
  double a18[4];
  double a19[4];
  double a20[4];
  double a21[4];
  double a22[4];
  double a23[4];
  double a24[4];
  double a25[4];
  double a26[4];
  double a27[4];
  double a28[4];
  double a29[4];
  double a30[4];
  double a31[4];
  double a32[4];
  double a33[4];
  double a34[4];
  double a35[4];
  double a36[4];
  double a37[4];
  double a38[4];
  double a39[4];
  double a40[4];
  double a41[4];
  double a42[4];
  double a43[4];
  double a44[4];
  double a45[4];
  double a46[4];
  double a47[4];
  double a48[4];
  double a49[4];
  double a50[4];
  double a51[4];
  double a52[4];
  double a53[4];
  double a54[4];
  double a55[4];
  double a56[4];
  double a57[4];
  double a58[4];
  double a59[4];
  double a60[4];
  double a61[4];
  double a62[4];
  double a63[4];
};

int matmul_send_i_particleMC(SINGinfo *s, struct matmul_hlt_struct0 *ip,
                         int n);

void send_i_matrix_16bbMC(SINGinfo *s, double a[16][64][4], int pe);

#define grape_i_particle_struct matmul_hlt_struct0
#define grape_i_particle_vector_struct matmul_hlt_vector_struct0
struct matmul_elt_struct0{
  double b00[4];
  double b01[4];
  double b02[4];
  double b03[4];
  double b04[4];
  double b05[4];
  double b06[4];
  double b07[4];
};
int matmul_send_elt_data0MC(SINGinfo *s, struct matmul_elt_struct0 *ip, int index_in_EM);
int matmul_move_elt_data0MC(SINGinfo *s, int index);



struct matmul_elt_struct1{
  double b10[4];
  double b11[4];
  double b12[4];
  double b13[4];
  double b14[4];
  double b15[4];
  double b16[4];
  double b17[4];
};
int matmul_send_elt_data1MC(SINGinfo *s, struct matmul_elt_struct1 *ip, int index_in_EM);
int matmul_move_elt_data1MC(SINGinfo *s, int index);


struct matmul_loopout_struct{
  double x0;
  double x1;

};
struct matmul_loopout_vectorstruct{
  double x0[256];
  double x1[256];

};
void matmul_grape_initMC(SINGinfo *s);
int matmul_grape_runMC(SINGinfo *s, int n);
int matmul_type2_runMC(SINGinfo *s, int n, double * loopout);
int matmul_type2_runMC_tb4_2(SINGinfo *s[NCHIP], int nchip, int n, double *loopout, int LDC);
int matmul_type2_runMC_tb4_2_ovl_dg(SINGinfo *s[NCHIP], int nchip, int n,
				    double *loopout, int LDC,
				    double next_a[NCHIP][NPE*NBB*256],
				    double al, double bt, int transpose,
				    int DIMK,
				    int istart,
				    int nloop,
				    int NOTA,
				    int LDA,
				    double a[][LDA],
				    int useoverlap);

int matmul_send_elt_data0MC_m(SINGinfo *s, struct matmul_elt_struct0 *ip,
			      int index_in_EM, int count);
int matmul_send_elt_data1MC_m(SINGinfo *s, struct matmul_elt_struct1 *ip,
			      int index_in_EM, int count);

int matmul_send_elt_data0MC_m_singlethread(int nchips,
					   SINGinfo *s[nchips],
					   struct matmul_elt_struct0 *ip,
					   int index_in_EM, int count,
					   int increment);
int matmul_send_elt_data1MC_m_singlethread(int nchips,
					   SINGinfo *s[nchips],
					   struct matmul_elt_struct1 *ip,
					   int index_in_EM, int count,
					   int increment);

void set_bbid_for_send_imatrixMC(SINGinfo *s,  int bbid);

void CTRL_hit_headerdata1(CTRLinfo *c,
			  int len,
			  int addr,
			  int bbn1,
			  int bbnm,
			  int seq,
			  UINT64 *data);

int sendoneamat(SINGinfo *s[NCHIP],
		int firstchip,
		int abcast,
		double next_a[NCHIP][NPE*NBB*256],
		int DIMK,
		int istart,
		int NOTA,
		int LDA,
		double a[][LDA]);

int sendoneamat_initialize(SINGinfo *s[], int firstchip, int abcast);
int sendoneamat_finalize();


UINT64 backgroundsend128_nchip(SINGinfo *s[NCHIP], int nc,
			       double *a[NCHIP], int index,
			       int nsend, int setup);

int get_matmul_msg_level();

void matmul_setnboards(int nb);
int  matmul_getnboards();
int  matmul_getnchips();


//#define SENDCHUNK 8 //256
//#define SENDCHUNK 16 //512
//#define SENDCHUNK 32 //1024
//#define SENDCHUNK 64 //2048
//#define SENDCHUNK 128 //4096
#define SENDCHUNK 256 //8192

//#define NLOOP 64 //8 //16 //64 
#define NLOOP 64 //16 //64 

#define NTHREAD 4
void gdrrun_threads(void (*run_func)(void *), void *param[NTHREAD]);

// functions defined in testmatmul32.c

void copytomata_em_1024_tb4_dg_partial_mc(int pestart, int peend,
					  int LDA, int NOTA, double a[][LDA],
					  int start, int nchip, int DIMK,
					  double *aem[]);
void copytomata_partial_mc(int iter, int nloop,
			   int LDA, int NOTA, double a[][LDA],
			   int start, int nchip, int DIMK,
			   double *aem[]);

void gdrdgemm_set_skip_cmat_mode(int mode);

#endif

