#include "vpm-local.h"
#include "vpm-sim-defs.h"
#include "vpm-board-sim-defs.h"
struct grape_j_particle_struct{
  double xj;
  double yj;
  double zj;
  double chargej;
};
int SING_send_j_particle(struct grape_j_particle_struct *jp,
                         int index_in_EM);
struct grape_i_particle_struct{
  double xi;
  double yi;
  double zi;
};
struct grape_i_particle_vector_struct{
  double xi[4];
  double yi[4];
  double zi[4];
};
int SING_send_i_particle(struct grape_i_particle_struct *ip,
                         int n);
struct SING_hlt_struct1{
  double test0;
  double test1;
  double test2;
  double test3;
  double test4;
};
int SING_send_hlt_data1(struct SING_hlt_struct1 *ip,
                         int peindex);
struct grape_result_struct{
  double accx;
  double accy;
  double accz;
};
struct grape_result_vector_struct{
  double accx[(4*NPE)];
  double accy[(4*NPE)];
  double accz[(4*NPE)];
};
int SING_get_result(struct grape_result_struct *rp);
void SING_grape_init();
int SING_grape_run(int n);
