#include "vpm-local.h"
#include "vpm-sim-defs.h"
#include "vpm-board-sim-defs.h"
#define grape_j_particle_struct  gravity_elt_struct0
struct grape_i_particle_struct{
  double xi;
  double yi;
  double zi;
  UINT32 idxi;
};
struct grape_i_particle_vector_struct{
  double xi[4];
  double yi[4];
  double zi[4];
  UINT32 idxi[4];
};
int gravity_send_i_particle(struct grape_i_particle_struct *ip,
                         int n);

struct gravity_elt_struct0{
  double xj;
  double yj;
  double zj;
  double mj;
  double eps2;
  UINT32 idxj;
};
int gravity_send_elt_data0(struct gravity_elt_struct0 *ip, int index_in_EM);
int gravity_move_elt_data0(int index);


struct gravity_result_struct{
  double accx;
  double accy;
  double accz;
  double pot;

};
struct gravity_result_vectorstruct{
  double accx[16];
  double accy[16];
  double accz[16];
  double pot[16];

};
int gravity_get_result(struct gravity_result_struct *rp);
#define  grape_result_struct gravity_result_struct 
void gravity_grape_init();
int gravity_grape_run(int n);
int gravity_type2_run(int n, void * loopout);
