#include "vpm-local.h"
#include "vpm-sim-defs.h"
#include "vpm-board-sim-defs.h"
#define grape_j_particle_struct  SING_elt_struct0
struct SING_hlt_struct0{
  double xi;
  double yi;
  double zi;
};
struct SING_hlt_vector_struct0{
  double xi[4];
  double yi[4];
  double zi[4];
};
int SING_send_i_particle(struct SING_hlt_struct0 *ip,
                         int n);
#define grape_i_particle_struct SING_hlt_struct0
#define grape_i_particle_vector_struct SING_hlt_vector_struct0
struct SING_elt_struct0{
  double xj;
  double yj;
  double zj;
  double mj;
  double eps2;
};
int SING_send_elt_data0(struct SING_elt_struct0 *ip, int index_in_EM);
int SING_move_elt_data0(int index);


struct SING_result_struct{
  double accx;
  double accy;
  double accz;
  double pot;

};
struct SING_result_vectorstruct{
  double accx[8];
  double accy[8];
  double accz[8];
  double pot[8];

};
int SING_get_result(struct SING_result_struct *rp);
#define  grape_result_struct SING_result_struct 
void SING_grape_init();
int SING_grape_run(int n);
int SING_type2_run(int n, void * loopout);
