//
// test.c
// test driver for simpletest
//
// J. Makino
//    Time-stamp: <05/03/15 22:03:08 makino>

#include <stdio.h>
#include "simpletest.h"

#define N 2

struct grape_j_particle_struct xj[N];
struct grape_i_particle_struct xi[N*4];
struct grape_result_struct result[N*4];

void init()
{
    int i;
    xj[0].xj=0;
    xj[1].xj=1;
    for(i=0;i<N;i++)SING_send_j_particle(xj+i, i);
    for(i=0;i<(N);i++)fprintf(stderr,"test init i=%d, xj= %e\n",i,xj[i].xj);
    
    xi[0].xi=0;
    for(i=1;i<(N*4);i++)xi[i]=xi[0];
    for(i=0;i<(N*4);i++)xi[i].xi=i;
    for(i=0;i<(N*4);i++)fprintf(stderr,"test init i=%d, x= %e\n",i,xi[i].xi);
}
    
print_result(struct grape_result_struct * result)
{
    struct grape_result_struct *p;
    int i;
    p=result;
    for(i=0;i<(N*4);i++){
	fprintf(stderr,"test result i=%d, lx= %e\n",i,p->lx);
	p++;
    }
}    

int main()
{
    int i, niparallel, ni, nj;
    ni=N*4;
    nj=N;
    SING_grape_init();
    init();
    niparallel = SING_number_of_pe()*4;
    for (i=0; i< ni;i+=niparallel){
	int njreal = nj/SING_number_of_bb();
	SING_send_i_particle(xi+i, niparallel);
	printf("i, njreal=%d %d\n", i, njreal);
	SING_grape_run(njreal);
	SING_get_result(result+i);
    }
    print_result(result);
}
