#include "vpm-local.h"
#include "vpm-sim-defs.h"
#include "vpm-board-sim-defs.h"
struct grape_j_particle_struct{
  double xj;
  double yj;
  double zj;
  double mj;
  double eps2;
  UINT32 idxj;
};
int XXX_send_j_particle(struct grape_j_particle_struct *jp,
                         int index_in_EM);
struct grape_i_particle_struct{
  double xi;
  double yi;
  double zi;
  UINT32 idxi;
};
struct grape_i_particle_vector_struct{
  double xi[4];
  double yi[4];
  double zi[4];
  UINT32 idxi[4];
};
int XXX_send_i_particle(struct grape_i_particle_struct *ip,
                         int n);
struct XXX_hlt_struct1{
  UINT32 idxii[4];
};
int XXX_send_hlt_data1(struct XXX_hlt_struct1 *ip,
                         int peindex);
struct XXX_elt_struct1{
  double xx;
};
int XXX_send_elt_data1(struct XXX_elt_struct1 *ip);
struct grape_result_struct{
  double accx;
  double accy;
  double accz;
  double pot;
};
struct grape_result_vector_struct{
  double accx[(4*NPE)];
  double accy[(4*NPE)];
  double accz[(4*NPE)];
  double pot[(4*NPE)];
};
int XXX_get_result(struct grape_result_struct *rp);
void XXX_grape_init();
int XXX_grape_run(int n);
