#include "vpm-local.h"
#include "vpm-sim-defs.h"
#include "vpm-board-sim-defs.h"
#define grape_j_particle_struct  SING_elt_struct0
struct SING_hlt_struct0{
  double xi;
  double yi;
  double zi;
  double vxi;
  double vyi;
  double vzi;
  double eps2i;
  UINT32 idxi;
  double ti;
};
struct SING_hlt_vector_struct0{
  double xi[4];
  double yi[4];
  double zi[4];
  double vxi[4];
  double vyi[4];
  double vzi[4];
  double eps2i[4];
  UINT32 idxi[4];
  double ti[4];
};
int SING_send_i_particle(struct SING_hlt_struct0 *ip,
                         int n);
#define grape_i_particle_struct SING_hlt_struct0
#define grape_i_particle_vector_struct SING_hlt_vector_struct0
struct SING_elt_struct0{
  double x0;
  double y0;
  double z0;
  double tj;
  double sx18;
  double sy18;
  double sz18;
  double jx6;
  double jy6;
  double jz6;
  double ax2;
  double ay2;
  double az2;
  double v0x;
  double v0y;
  double v0z;
  double mj;
  double eps2;
  UINT32 idxj;
};
int SING_send_elt_data0(struct SING_elt_struct0 *ip, int index_in_EM);
int SING_move_elt_data0(int index);


void SING_grape_init(int chipid);
int SING_grape_run(int n);
int SING_type2_run(int n, void * loopout);
