//
// dgemmbody.h
//

#ifndef __DGEMMBODY_H
#define __DGEMMBODY_H

#include <typedef.h>
void setdqsdelayandch(int x, int y);
void setdooverlap(int x);
void print_matrix2(int M, int N, int LDA, double (*A)[]);
void set_matrix_2(int M, int N, int K, double (*A)[],double (*B)[],double (*C)[],double (*C2)[]);

void set_matrix_2a(int M, int N, int K,
		   int  LDA, int LDB, int LDC,
		   double (*A)[],double (*B)[],double (*C)[],double (*C2)[]);

void gdr_dgemm_(int *NOTA, int *NOTB, int *M, int *N, int *K,
		double *ALPHA,
		double *BETA,
		int *LDA,
		int *LDB,
		int *LDC,
		double A[][(*LDA)],
		double B[][(*LDB)],
		double C[][(*LDC)],
		int *gdrdoneflag);
double check_matrix(int M, int N, int LDA, int LDB, double A[][LDA], double B[][LDB]);
double check_matrix_fast(int M, int N, int LDA, int LDB,
			 double A[][LDA], double B[][LDB],int checkmode);

void gdrsetforceswapab();
void gdrresetforceswapab();
void gdrsetskipsendjmat();
void gdrresetskipsendjmat();
void gdrsetusemultithread();
void gdrresetusemultithread();
void gdrsetboardid(int id);
int  gdrgetboardid();
void gdrsetnboards(int nb);
int  gdrgetnboards();

void set_coc_reg(int address, UINT64 data);

#endif


