int matmul_type2_runMC_tb4_2_ovl_dg(SINGinfo *s[NCHIP], int nchip, int n,
				    double *loopout, int LDC,
				    double next_a[NCHIP][NPE*NBB*256],
				    double al, double bt, int transpose,
				    int DIMK,
				    int istart,
				    int NOTA,
				    int LDA,
				    double a[][LDA])
{
    static int check_dma_at_first_call = 1;
    int i , j, k, l, result_size, nloop;
    int buf_offsetw, buf_offsetr;
    int send128;
    int sendc = SENDCHUNK*32;
    int wind[NCHIP] = {0,1,3,2};
    double *p, *dmaw[NCHIP], *nap[NCHIP];
    UINT64 start, sing, copy, run, fini, init, loops, loop, cmatcopy, ispstart;
    int lmsize=256*512;
    volatile UINT64 *test;
    int dmawsize;
    singchip_p = s;
    for(i=0;i<nchip;i++)nap[i]=next_a[i];
    nloop = det_nloop(n);
    result_size = sizeof(struct matmul_loopout_vectorstruct)/sizeof(double)*nloop;
    dmawsize = result_size/nchip;
    start = rdtsc2();
    for(i=0;i<nchip;i++){
	SING_EM_fifoclrMC(s[i]);
	matmul_move_elt_data0MC(s[i], 0);
	matmul_move_elt_data1_nosendMC(s[i], 0);
    }
    p = loopout;
    buf_offsetr = 0;
    buf_offsetw = 0;
    send128 = 0;
    ispstart = 0;

    for(j=0;j<nchip;j++){
	dmaw[j] = (double*)(s[j]->c->h->dmaw_buf);
	int k;
	for (k=0;k<2;k++){
	    hib_register_dma_seqMC(s[j]->c->hib_id,k, 1,dmawsize,
				   (void*)(dmaw[j]+(1-k)*dmawsize));
	}

    }
    
    copy =0;
    CTRL_beginbcast(s[0]->c);

    if(hib_get_dmacheck_mode()){
	for(j=0;j<nchip;j++){
	    hib_initialize_dmawbufferMC(s[j]->c->hib_id,dmawsize,
					(void*)(dmaw[j]+buf_offsetw));
	}
    }
    
    CTRL_coc_setflags(0,-1,-1);
    SING_send_instlist(s[0]->c, &(s[0]->isp.instlists[ids[1]]), 1, 0);
    for(j=0;j<nchip;j++){
	if (use_old_dmaw){
	    hib_start_dmawMC(s[j]->c->hib_id, dmawsize, (void*)(dmaw[j]+buf_offsetw));
	}else{
	    hib_start_dma_seqMC(s[j]->c->hib_id, 1, 1);
	}
    }
    init = rdtsc2() - start;
    loops = rdtsc2();
    int icopya=0;
    int coc_dmaw_id = -1;
    for(i=0;i<n;i+=nloop){ // 2column
	run = rdtsc2();
	if (DIMK==2048){
	    if (i==0){
		copytomata_em_1024_tb4_dg_partial_mc(icopya, icopya+2,
						     LDA, NOTA,  a,
						     istart, nchip,
						     DIMK, nap);
		icopya += 2;
	    }
	}
	gdr_multi_cntl_setstate(3);
	int coc_flag = 7;
	if (icopya >= NPE) coc_flag = 0;
	if (i +nloop >= n) coc_flag = 0;
	CTRL_coc_setflags(coc_flag,-1, coc_dmaw_id);
	SING_send_instlist(s[0]->c, &(s[0]->isp.instlists[ids[2]]), nloop, 1);
	start = rdtsc2();
	ispstart += start - run; 
	start = rdtsc2();

	if (i){
	    calcmatc(p, dmaw, 0,1,nloop, result_size, buf_offsetr,
		     al, bt, LDC, transpose);
	}
#pragma omp parallel
#pragma omp sections
	{
#pragma omp section
	    {
		if (icopya < NPE+2){
		    sendamat(s,  next_a, i, &send128, sendc,  DIMK,0);
		}
		
		if (DIMK==2048){
		    if (icopya < NPE){
			copytomata_em_1024_tb4_dg_partial_mc(icopya, icopya+2,
							     LDA, NOTA,  a,
							     istart, nchip,
							     DIMK, nap);
		    }
		    icopya += 2;
		}
	    }
#pragma omp section
	    {
		if(i){
		    calcmatc(p, dmaw, 1,nloop, nloop, result_size, buf_offsetr,
			     al, bt, LDC, transpose);
		}
	    }
	}
	if(i != 0){
	    //start = rdtsc2();
	    if(transpose==0){
		p += LDC*2*nloop;
	    } else {
		p += 2*nloop;
	    }
	    //sing = rdtsc2() - start;
	} 

	if(i!=(n-nloop)){
	    if(i%(nloop*2)==0){
		buf_offsetw = result_size/nchip;
		buf_offsetr = 0;
	    } else {
		buf_offsetw = 0;
		buf_offsetr = result_size/nchip;
	    }
	}

	if(hib_get_dmacheck_mode()){
	    if(i!=(n-nloop)){
		for(j=0;j<nchip;j++){
		    hib_initialize_dmawbufferMC(s[j]->c->hib_id,
						result_size/nchip,
						(void*)(dmaw[j]+buf_offsetw));
		}
	    }
	}
		
	for(j=0;j<nchip;j++){
	    hib_finish_dmawMC(s[j]->c->hib_id);
	}
	coc_dmaw_id = -1;
	for(j=0;j<nchip;j++){
	    if(i!=(n-nloop)){
		start = rdtsc2();
		if (use_old_dmaw){
		    hib_start_dmawMC(s[j]->c->hib_id, dmawsize, (void*)(dmaw[j]+buf_offsetw));
		}else{
		    int seqid = (i%(nloop*2))? 1:0;
		    hib_start_dma_seqMC(s[j]->c->hib_id, seqid, 1);
	    //coc_dmaw_id = seqid;
		}
		ispstart += rdtsc2() - start;
	    }
	    //	    if(debug_matmul)fprintf(stderr,"dmastarted %d\n",j);
	}
	if (icopya <= NPE){
	    while((rdtsc2()-st)<(wait+00000)) {}
	}else{
	    while((rdtsc2()-st)<(wait+150000)) {}
	}	    
	gdr_multi_cntl_setstate(1);

	//	if(debug_matmul)fprintf(stderr,"loop end\n");
    }
    loop = rdtsc2() - loops;
    loops = rdtsc2();
    backcalcmatc(p, dmaw, nloop, result_size, buf_offsetw, al, bt, LDC, transpose);
    cmatcopy = rdtsc2() - loops;
    int sendsize=DIMK*DIM0*DIM1/2048/sendc/NCHIP;
    int firstzero=1;
    while (send128 < sendsize){
	//	fprintf(stderr,"send128, compare=%d %d\n",send128 ,sendsize);
	
	//	fronttask_amat(s, next_a, firstzero, &send128, sendc, DIMK, 
	//		       p, dmaw, nloop, result_size, buf_offsetr, al, bt, LDC, transpose);
	sendamat(s, next_a, firstzero, &send128, sendc, DIMK,1);

	firstzero=1;
	//	usleep (100);
    }
	

    SING_EM_fifoclrMC(s[0]);
    CTRL_endbcast(s[0]->c);

#ifdef BENCHMATMULLOOP  
    printf("matmul init : %lld [clk], loop %lld [clk], cmatcopy %lld [clk] , ispstart %lld [clk] \n", init, loop, cmatcopy, ispstart); 
#endif
    return send128;
}

