#ifndef _SING_LM_H
#define _SING_LM_H

#include <typedef.h>
#include <sing_conf.h>

typedef struct
{
  UINT64 convtable[MAX_CONVERSION];
  int lm_hostlen;
  int lm_length;
  int lm_nword;

  int firstsend;
  int ipart_id;
} SINGLM_INFO;

void init_lminfo(SINGLM_INFO *info);
int SING_LM_write_regconv_i(SINGLM_INFO *info, CTRLinfo *c, int length, int *conversions);
int SING_LM_write_i(SINGLM_INFO *info, SINGISP_INFO *ispinfo, CTRLinfo *c, void *hostp, int lmoffset, int peeach);

int SING_LM_write_i_2(SINGLM_INFO *info, SINGISP_INFO *ispinfo, CTRLinfo *c, void *hostp, int lmoffset, int peeach);

int SING_LM_write_i_3(SINGLM_INFO *info, SINGISP_INFO *ispinfo, CTRLinfo *c, void *hostp, int lmoffset, int peeach, int nhead) ;

#endif
